#File loci_from_Exonerate.pm

package loci_from_Exonerate;

#use strict;
#use warnings;
#use diagnostics;
#use DBI;


my %SNPs2test;
our $strand='+';


sub parser{
    my ($infile,$length)=@_;

    open(MAP,"$infile") if ( -e "$infile" ) or die "$!\n\n";
    my $flag=0;
    my (@query,@match,@target,@genomic);
    my ($Match,$Genom,$Query)=('','','');
    my ($up,$down);
    my $margeL=0;
    my (@exonUp,@cdsUp);
    my $seuil=0;		#To limit processing if matches are too bad
    while(<MAP>){
	if ($flag==1 and $margeL==0 and $_ =~ /^( +\d+ : )[\w\-\{\} \>\<]+ : +\d+$/){
	    $margeL=length($1);
	}
	if ($flag==0 and $_ =~ /^ +Target range: (\d+) -> (\d+)/){
	    $strand='-' if ($1 > $2);
	    $flag=1;
	}
	elsif ($_ =~ /^vulgar:/){
	    $flag=8;
	}
	elsif ( defined($exonUp[0]) and $_ =~ /^\# --- END OF GFF DUMP ---/){
	    last;
	}
	elsif ($flag==1 and $_ =~ /^ +\d+ : ([\w\-\{\} \>\<]+) : +\d+/){
	    @query=(@query,$_);
	    $Query=$Query.$1;
	    $flag++;
	}
	elsif ($flag==2 and $_ =~ /^ +[\|\+\-\{\}\dbp\.\!\:\#]+/){
	    @match=(@match,$_);
	    $_ =~ s/^.{$margeL}//;
	    $Match=$Match.$_;
	    chomp($Match);
	    $flag++;
	}
	elsif ($flag==3 and $_ =~ /^ +[\w\-\{\}\#]+/){
	    @target=(@target,$_);
	    $flag++;
	}
	elsif ($flag==4 and $_ =~ /^ +(\d+) : ([\w\-\{\}\.]+) : +(\d+)/){
	    @genomic=(@genomic,$_);
	    $up=$1;
	    $Genom=$Genom.$2;
	    $down=$3;
	    $flag=1;
	}
	elsif ($flag==8 and $_ =~ /exonerate:protein2genome\tsimilarity\t\d+\t/){
	    my $similarity_query=$_;
	    chomp($similarity_query);
	    $similarity_query =~ s/^[^\;]+\; //;
	    while($similarity_query =~ m/^ ?Align (\d+) /){
		@cdsUp=(@cdsUp,$1);
		$similarity_query =~ s/^ ?Align \d+ \d+ \d+ \;//;
	    }
	    $flag=9;
	}
	elsif ($flag==9 and $_ =~ /exonerate:protein2genome\texon\t(\d+)\t/){
	    @exonUp=(@exonUp,$1) if ($strand eq '+');
	    @exonUp=(@exonUp,($length-$1+1)) if ($strand eq '-');
	}
    }
    close MAP;
    print STDERR "[@cdsUp]\n{@exonUp}\n";

    my $drap=0;
    my $exonNbr=0;
    my ($locus,$lieu)=(0,0);
    for(my $i=0; $i<length($Match); $i++){
	my $matched_symbol=substr($Match,$i,1);
	if ($drap==3 and $matched_symbol =~ /^[\+\-]$/){
	    $drap=0;
	    $locus=0;
	    $exonNbr++;
	    print STDERR $matched_symbol, substr($Genom,$i,1), "\t", substr($Query,$i,1), "\n";
	}
	elsif ($matched_symbol =~ /^[\+\-]$/){
	    $drap++;
	    print STDERR $matched_symbol, substr($Genom,$i,1), "\t", substr($Query,$i,1), "\n";
	}
#	elsif ($matched_symbol =~ /[ \|\.\!\:]/ and $strand eq '+' and substr($Genom,$i,1) !~ /[\{\}\.a-z\-]/){
	elsif ($matched_symbol =~ /[ \|\.\!\:\#]/ and $strand eq '+' and substr($Genom,$i,1) !~ /[\{\}\.a-z]/){
	    my $location=$exonUp[$exonNbr]+$locus;
	    my $peptide_pos='';
	    $peptide_pos=$cdsUp[0]+$lieu if (substr($Query,$i,1) =~ /[A-Z]/);
	    $lieu++ if (substr($Query,$i,1) =~ /[A-Z]/);
	    my $line=$matched_symbol.substr($Genom,$i,1)."\t".$location."\t".substr($Query,$i,1)."\t".$peptide_pos;
	    %SNPs2test=(%SNPs2test, $location => "$line") if ($matched_symbol eq "\|");
	    print STDERR $line."\n";
	    $locus++;
	}
#	elsif ($matched_symbol =~ /[ \|\.\!\:]/ and $strand eq '-' and substr($Genom,$i,1) !~ /[\{\}\.a-z\-]/){
	elsif ($matched_symbol =~ /[ \|\.\!\:\#]/ and $strand eq '-' and substr($Genom,$i,1) !~ /[\{\}\.a-z]/){
	    my $location=$exonUp[$exonNbr]-$locus;
	    my $peptide_pos='';
	    $peptide_pos=$cdsUp[0]+$lieu if (substr($Query,$i,1) =~ /[A-Z]/);
	    $lieu++ if (substr($Query,$i,1) =~ /[A-Z]/);
	    my $line=$matched_symbol.substr($Genom,$i,1)."\t".$location."\t".substr($Query,$i,1)."\t".$peptide_pos;
	    %SNPs2test=(%SNPs2test, $location => "$line") if ($matched_symbol eq "\|");
	    print STDERR $line."\n";
	    $locus++;
	}
	else{
	    print STDERR $matched_symbol, substr($Genom,$i,1), "\t", substr($Query,$i,1), "\n";
	    $lieu++ if (substr($Query,$i,1) =~ /U/);
	}
    }


    my $refpos=\%SNPs2test; #Use perl references to send two variables (mem address for the 2 hashes) instead of 2 hashes,
                            #and easily, and properly, get them in the main script !
    return($refpos);
}


sub SNPs{
#SNPs checking
    my ($chr,$orgm,$release,$host,$user,@pos2check)=@_;
    my $db=&species::species2tab($orgm);
    my %posVal;

#Database parameters
    my $dbnameG='ensembl_mart_'.$release;
    my $dbname='snp_mart_'.$release;
#Remote Access to EnsEMBL 
    my $dbh = DBI->connect("dbi:mysql:database=$dbname;host=$host","$user") or die $DBI::errstr;

    my $sth=$dbh->prepare("SELECT DISTINCT d.snp_chrom_start, d.chr_name, d.allele, d.is_synonymous, d.is_nonsynonymous, d.is_frameshift_coding, d.peptide_shift FROM ${dbname}.${db}_snp__snp__main m, ${dbnameG}.${db}_gene_ensembl__snp__dm d WHERE d.snp_id_key = m.snp_id_key AND m.snp_chrom_start=d.snp_chrom_start AND m.chr_name=? AND m.snp_chrom_start=? AND \(d.is_synonymous='1' OR d.is_nonsynonymous='1' OR d.is_frameshift_coding='1'\)");
    for(my $k=0; $k<=$#pos2check; $k++){
	$sth->execute($chr,$pos2check[$k]);

#Output format
	while (my ($snp_chrom_start, $cHr, $allele, $syn, $nosyn, $frameshit, $peptide_shift) = ($sth->fetchrow_array)){
	    $syn=0 if ( ! defined($syn) );
	    $nosyn=0 if ( ! defined($nosyn) );
	    $frameshit=0 if ( ! defined($frameshit) );
	    $peptide_shift='' if ( ! defined($peptide_shift) );

	    %posVal=(%posVal,$snp_chrom_start => "$cHr\t$allele\t$syn\t$nosyn\t$frameshit\t$peptide_shift") if ($cHr eq $chr and $snp_chrom_start==$pos2check[$k] and ($syn==1 or $nosyn==1 or $frameshit==1));
	}
	$sth->finish;
    }
    return(%posVal);
}


1;

=head2 sub parser

=over 4

=item Parse Exonerate output to get only exact matching positions

=item my ($infile,$genomic_length)=@_;

=back

=cut

=head2 sub SNPs

=over 4

=item Check at EnsEMBL if positions are variation ones

=item my ($chr,$orgm,$release,$host,$user,@pos2check)=@_;

=back

=cut
