#File pdb2fas.pm

package pdb2fas;

#use strict;
#use warnings;
#use diagnostics;


our %seqRes;
our @clefs;
our $failure=0;
our $Chain='';


#AA convertion, from 3 letters to 1
sub AA{
    my ($three)=@_;
    $three=lc($three);
    $three=ucfirst($three);

    my %aa=('Ala' => 'A', 'Phe' => 'F', 'Leu' => 'L', 'Ile' => 'I',
	    'Met' => 'M', 'Val' => 'V', 'Ser' => 'S', 'Pro' => 'P',
	    'Thr' => 'T', 'Tyr' => 'Y', 'His' => 'H', 'Gln' => 'Q',
	    'Asn' => 'N', 'Lys' => 'K', 'Asp' => 'D', 'Glu' => 'E',
	    'Cys' => 'C', 'Trp' => 'W', 'Arg' => 'R', 'Gly' => 'G',
            'X' => '', 'Xxx' => '');

    if (exists $aa{$three}){
	return($aa{$three});
    }
    else {
	return('X');
    }
}


sub fasta{
    my ($pdbFile,$chain)=@_;
    $chain='_' if ($chain eq '');
    if ($chain !~ /^[\w_]$/){
	die "\n\tThe chain ID is wrong\n\tTry again !\n\n";
    }


    my $subStruct='';
    open(PDB,"$pdbFile");
    while(<PDB>){
	if ($chain eq '_' and $_ =~ /^ATOM +\d+ +.....(\w\w\w) +(\d+) /){	#No chain ID in PDB file
	    %seqRes=(%seqRes, $2 => $1);
	}
	elsif ($chain eq '_' and $_ =~ /^ATOM +\d+ +.....\w\w\w *\w *\d+ /){ #Chain ID but only 1 in PDB file
	    my $line=$_;
	    if ($subStruct eq '' and $line =~ /^ATOM +\d+ +.....\w\w\w *(\w) *\d+ /){
		$subStruct=$1;
	    }
	    elsif ($line =~ /^ATOM +\d+ +....(\w\w\w) *$subStruct *(\d+) /){
		%seqRes=(%seqRes, $2 => $1);
	    }
	    else{
		$failure=1;
		print "\n\tProblem with the chain(s) of the PDB structure\n\tSpecify one of them\n\n";
		last;
	    }
	}
	elsif ($chain ne '' and $_ =~ /^ATOM +\d+ +.....(\w\w\w) *$chain *(\d+) /){ #Several chain ID in PDB file
	    %seqRes=(%seqRes, $2 => $1);
	}
    }
    close PDB;
    $chain=$subStruct if ($subStruct ne '');
    $Chain=$chain;
    $Chain='' if ($chain eq '_');
    @clefs=sort {$a <=> $b} keys(%seqRes);
    my %Xpositions;
    if ( %seqRes eq 0 ){ # Test si la table de hashage est vide
	$failure=1;
	print "\n\tCannot extract the chain specified\n\tMaybe it is wrong\n\n";
    }
    else {
	my $taille=$clefs[$#clefs]-$clefs[0]+1;
	if ($taille != ($#clefs+1)){
	    for(my $k=$clefs[0]; $k<=$clefs[$#clefs]; $k++){
		if ( exists( $seqRes{$k} ) ){
		}
		else {
		    %seqRes=(%seqRes, $k => 'X');
		    %Xpositions=(%Xpositions, $k => $k);
		}
	    }
	}
	@clefs=sort {$a <=> $b} keys(%seqRes);
	my $pdbName=$pdbFile;
	$pdbName =~ s/^.*(\d\w\w\w)\.pdb.*$/$1/;
	open(FASTA,">$pdbName.fas");
	print FASTA ">$pdbName:$chain\n";
	for(my $i=0; $i<=$#clefs; $i++){
	    if ($i > 0 and $clefs[$i]==($clefs[$i-1]+1)){
		print FASTA &AA("$seqRes{$clefs[$i]}") if (&AA("$seqRes{$clefs[$i]}") =~ /^[A-Z]$/);
	    }
	    elsif ($i > 0){
#		print FASTA 'X';
	    }
	    elsif ($i==0){
		print FASTA &AA("$seqRes{$clefs[$i]}") if (&AA("$seqRes{$clefs[$i]}") =~ /^[A-Z]$/);
	    }
#Prob si trous !
	}
	print FASTA "\n";
	close FASTA;
	print "\n\tFasta file for the structure has been obtained ...\n" if ($failure != 1);
    }

    my $holes=\%Xpositions;
    return ($holes);
}

1;

=head2 sub fasta

=over 4

=item Check the chain number in the PDB file

=item none, only one peptide chain, several (then exits)

=item extract the chain residues in fasta

=item my ($pdbFile,$chain)=@_;

=item my ($pdbFile)=@_;

=back

=cut

=head2 sub AA

=over 4

=item Convert amino acid three-letters code to one-letter code

=back

=cut
