#File species.pm

package species;


#Species name conversions between web site/ fasta sequences and MySQL tables (for EnsEMBL)
sub species2tab{
    my ($orgm)=@_;

    my $result='';
    if ($orgm eq 'Homo_sapiens'){
        $result='hsapiens';
    }
    elsif ($orgm eq 'Mus_musculus'){
	$result='mmusculus';
    }
    elsif ($orgm eq 'Rattus_norvegicus'){
	$result='rnorvegicus';
    }
    elsif ($orgm eq 'Gallus_gallus'){
	$result='ggallus';
    }
    elsif ($orgm eq 'Danio_rerio'){
	$result='drerio';
    }
    elsif ($orgm eq 'Canis_familiaris'){
	$result='cfamiliaris';
    }
    elsif ($orgm eq 'Anopheles_gambiae'){
	$result='agambiae';
    }

    return($result);
}

1;


=head2 sub species2tab

=over 4

=item Convert species names for fasta sequences to names for MySQL tables

=item my ($orgm)=@_;

=back

=cut
