#!/bin/sh

species=$1
if [ -z "$species" ];then
    echo -e "\n\tYou must specify the species to get\n\tthe last chromosomic sequences from EnsEMBL\n\n\te.g.: $0 Homo_sapiens\n"
    exit
fi

current='_'
if [ $species == 'Homo_sapiens' ]; then
#    current='human' #Names have changed for EnsEMBL release 35
    current='homo_sapiens'
fi
if [ $species == 'Mus_musculus' ]; then
#    current='mouse'
    current='mus_musculus'
fi
if [ $species == 'Rattus_norvegicus' ]; then
#    current='rat'
    current='rattus_norvegicus'
fi
if [ $species == 'Gallus_gallus' ]; then
#    current='chicken'
    current='gallus_gallus'
fi
if [ $species == 'Danio_rerio' ]; then
#    current='zebrafish'
    current='danio_rerio'
fi
if [ $species == 'Canis_familiaris' ]; then
#    current='dog'
    current='canis_familiaris'
fi
if [ $species == 'Anopheles_gambiae' ]; then
#    current='mosquito'
    current='anopheles_gambiae'
fi

if [ $current == '_' ];then
    echo -e "\n\tThis species is not available for variations mapping\n"
    exit
fi


wget -O README "ftp://ftp.ensembl.org/pub/current_${current}/data/fasta/dna/README"
wget "ftp://ftp.ensembl.org/pub/current_${current}/data/fasta/dna/${species}.*.dna.chromosome.*.fa.gz"

for gz in *.fa.gz
do
  gunzip -f $gz
  fasta=${gz%%.gz}
  chr=${fasta#*_*.dna.chromosome.}
  ln -fs $PWD/$fasta ${species}.dna.chromosome.${chr}
done

echo -e "\n\tIf links are fine, you can\n\tremove older chromosomic sequences\n\tand update the release version in SoS.pl\n"

exit

