#File locus_at_ensembl.pm

package locus_at_ensembl;

#use strict;
#use warnings;
#use diagnostics;
#use DBI;
use Term::ANSIColor;

our $chr='';

sub request_at_EnsEMBL{
    my ($orgm,$pdb_ID,$cache,$release,$host,$user)=@_;
    my $db=&species::species2tab($orgm);

#Database parameters
    my $dbname='ensembl_mart_'.$release;
#Remote Access to EnsEMBL 
    my $dbh = DBI->connect("dbi:mysql:database=$dbname;host=$host","$user") or die $DBI::errstr;

    my $sth=$dbh->prepare("SELECT DISTINCT d.gene_id_key, d.dbprimary_id, d.display_id_list, m.chr_name FROM ${db}_gene_ensembl__xref_pdb__dm d, ${db}_gene_ensembl__gene__main m WHERE d.gene_id_key=m.gene_id_key AND d.dbprimary_id='${pdb_ID}'");
    $sth->execute;
    my $compteur=0;
#    print STDERR "Gene_ID\tChr\tPDB_ID\tlist\n";
    while (my ($gene_ID, $PDB, $list, $cHr) = ($sth->fetchrow_array)){
	if ($PDB eq $pdb_ID){
	    $compteur++;
	    $chr=$cHr if ($compteur==1);
	    $list=$list || '_';
	    print STDERR "Gene_ID\tChr\tPDB_ID\tlist\n" if ($compteur==1);
	    print STDERR "$gene_ID\t$cHr\t$PDB\t$list\n";
	}
#	print "\n\tWarning: there are several matches in EnsEMBL for this PDB id\n\tMaybe it is a complex with several chains mapping different loci\n\n" if ($compteur==2);
    }
    print "\n\tWarning: there are several matches in EnsEMBL for this PDB id\n\tMaybe it is a complex with several chains mapping different loci\n\n" if ($compteur>1);

    if ($chr eq ''){
	my $coloriser=colored ['on_red'], "${pdb_ID}";
	print STDERR "\n\n\tThis PDB ID ($coloriser) doesn't seem to have been\n\tmatched in EnsEMBL for this species\n\n";
	unlink("${pdb_ID}.fas","${pdb_ID}.pdb");
        chdir "../"; rmdir $cache;
	exit;
    }

#End
    $sth->finish;
    $dbh->disconnect;
}


1;

=head2 sub request_at_EnsEMBL

=over 4

=item Check if the PDB id is known at EnsEMBL

=item If it is, retrieve the chromosome locus

=item my ($orgm,$pdb_ID,$cache,$release,$host,$user)=@_;

=back

=cut
